import fischertechnik.utility.math as ft_math
import time
from fischertechnik.controller.Motor import Motor
from lib.controller import *

speed_fwd = None
speed_rotate = None
i1 = None
suc = None
line = None
i2 = None
white = None
endline = None
calib_i1_min = None
calib_i1_max = None
calib_i2_min = None
calib_i2_max = None


def init_calib_sensors():
    global speed_fwd, speed_rotate, i1, suc, line, i2, white, endline, calib_i1_min, calib_i1_max, calib_i2_min, calib_i2_max
    i1 = 0
    i2 = 0
    endline = False
    white = False
    line = 0
    calib_i1_min = 2000
    calib_i1_max = 100
    calib_i2_min = 2000
    calib_i2_max = 100


def calib_line_rotate360():
    global speed_fwd, speed_rotate, i1, suc, line, i2, white, endline, calib_i1_min, calib_i1_max, calib_i2_min, calib_i2_max
    TXT_M_M1_encodermotor.set_speed(int(200), Motor.CCW)
    TXT_M_M2_encodermotor.set_speed(int(200), Motor.CW)
    TXT_M_M1_encodermotor.set_distance(int(323), TXT_M_M2_encodermotor)
    while not (not TXT_M_M1_encodermotor.is_running()):
        calib_i1_min = min([calib_i1_min, TXT_M_I1_color_sensor.get_voltage()])
        calib_i1_max = max([calib_i1_max, TXT_M_I1_color_sensor.get_voltage()])
        calib_i2_min = min([calib_i2_min, TXT_M_I2_color_sensor.get_voltage()])
        calib_i2_max = max([calib_i2_max, TXT_M_I2_color_sensor.get_voltage()])
        time.sleep(0.01)
    print('calibLine min:{} {} max:{} {}'.format(calib_i1_min, calib_i2_min, calib_i1_max, calib_i2_max))


def read_line_sensors():
    global speed_fwd, speed_rotate, i1, suc, line, i2, white, endline, calib_i1_min, calib_i1_max, calib_i2_min, calib_i2_max
    i1 = ft_math.map(TXT_M_I1_color_sensor.get_voltage(), calib_i1_min, calib_i1_max, 100, 0)
    i2 = ft_math.map(TXT_M_I2_color_sensor.get_voltage(), calib_i2_min, calib_i2_max, 100, 0)
    line = (i1 - i2) * 1
    endline = i1 < 5 and i2 < 5
    white = i1 > 95 and i2 > 95


def follow_line_step(speed_fwd, speed_rotate):
    global i1, suc, line, i2, white, endline, calib_i1_min, calib_i1_max, calib_i2_min, calib_i2_max
    suc = is_on_line()
    if suc:
        TXT_M_M1_encodermotor.set_speed(int(speed_fwd), Motor.CCW)
        TXT_M_M1_encodermotor.start()
        TXT_M_M2_encodermotor.set_speed(int(speed_fwd), Motor.CCW)
        TXT_M_M2_encodermotor.start()
    elif line < 25:
        TXT_M_M1_encodermotor.set_speed(int(speed_rotate), Motor.CCW)
        TXT_M_M1_encodermotor.start()
        TXT_M_M2_encodermotor.set_speed(int(0), Motor.CCW)
        TXT_M_M2_encodermotor.start()
    elif line > -25:
        TXT_M_M1_encodermotor.set_speed(int(0), Motor.CCW)
        TXT_M_M1_encodermotor.start()
        TXT_M_M2_encodermotor.set_speed(int(speed_rotate), Motor.CCW)
        TXT_M_M2_encodermotor.start()
    else:
        pass
    return suc


def print_line_info():
    global speed_fwd, speed_rotate, i1, suc, line, i2, white, endline, calib_i1_min, calib_i1_max, calib_i2_min, calib_i2_max
    print('line:{} i:{} {} {}{}'.format(line, i1, i2, 'W' if white else '', 'E' if endline else ''))


def is_on_line():
    global speed_fwd, speed_rotate, i1, suc, line, i2, white, endline, calib_i1_min, calib_i1_max, calib_i2_min, calib_i2_max
    return line <= 50 and line >= -50


def get_line():
    global speed_fwd, speed_rotate, i1, suc, line, i2, white, endline, calib_i1_min, calib_i1_max, calib_i2_min, calib_i2_max
    return line


def get_i1():
    global speed_fwd, speed_rotate, i1, suc, line, i2, white, endline, calib_i1_min, calib_i1_max, calib_i2_min, calib_i2_max
    return i1


def get_i2():
    global speed_fwd, speed_rotate, i1, suc, line, i2, white, endline, calib_i1_min, calib_i1_max, calib_i2_min, calib_i2_max
    return i2


def is_white():
    global speed_fwd, speed_rotate, i1, suc, line, i2, white, endline, calib_i1_min, calib_i1_max, calib_i2_min, calib_i2_max
    return white


def is_endline():
    global speed_fwd, speed_rotate, i1, suc, line, i2, white, endline, calib_i1_min, calib_i1_max, calib_i2_min, calib_i2_max
    return endline
